#define NUMTELS 6
#define BASELINES 15
#define NUMDLS 6


/* Big structure used for python configuration AND for 
   sending info to the Spooler */

#ifndef __BOOLEAN__
#define __BOOLEAN__
enum BOOL {FALSE, TRUE};
typedef enum BOOL boolean;
#endif

/** Spooler messages*/
enum {
  HEADER,
  DATA,
  END,
  KILL
};
/* This structure is used to communicate data to 
   the python interface and with the spooler */
struct pythonconfig {
  int NTels;
  int BeamOrder[NUMTELS];
  int RefTel;
  unsigned int FiberExplorerX[NUMTELS];
  unsigned int FiberExplorerY[NUMTELS];
  float lambda;
  float bandwidth;
  float gdtThreshold[BASELINES];  //should really be in the gdt structure!
  float gdtGain;
  unsigned char cpeak[BASELINES];
  unsigned char cpeak0[BASELINES];
  unsigned char cpeak1[BASELINES];
  unsigned char bkgndNoiseCol;
  char fileDescription[30];
  char MircFilter1[30];
  char MircFilter2[30];
  char ConfigName[30]; 
  char TelKey[30];
  char observer[30];
  char comment1[30];
  char comment2[30];
};
typedef struct pythonconfig pythonconfig_struct;

struct theGDT {
  double dlOffsets[NUMDLS];
  double manualOffset[NUMDLS];
  boolean activeBaselines[BASELINES];
  boolean gdtLock;
  boolean continuousReadout;
};
typedef struct theGDT gdt_struct;

struct theHeader {
  double frametime;
  unsigned long numberOfFrames;
  unsigned short rows;
  unsigned short cols;
  unsigned short rowOffset;
  unsigned short colOffset;  
  unsigned short nreads;
  unsigned short numberOfCoadds;
  unsigned short framesPerReset;
  unsigned short exptime;
  float voffset;
  float vreset;  
  float vd;
  float ictl;
  float tint;
  unsigned char do_image_save;
  char image_directory[30];
  pythonconfig_struct  pyconfig;
  gdt_struct gdt;
  double dloffsets[NUMDLS];
 };


typedef struct theHeader header_struct;
